diff --git a/BUILD.bazel b/BUILD.bazel
index 40c040226..89de9e40e 100644
--- a/BUILD.bazel
+++ b/BUILD.bazel
@@ -33,9 +33,9 @@ java_library(
         "//protobuf",
         "//stub",
         "//stub:javax_annotation",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
         "@com_google_protobuf//:protobuf_java",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
@@ -47,8 +47,8 @@ java_library(
         "//protobuf-lite",
         "//stub",
         "//stub:javax_annotation",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
@@ -56,7 +56,7 @@ java_plugin(
     name = "auto_value",
     generates_api = 1,
     processor_class = "com.google.auto.value.processor.AutoValueProcessor",
-    deps = ["@com_google_auto_value_auto_value//jar"],
+    deps = ["@grpc_java_maven//:com_google_auto_value_auto_value"],
 )
 
 java_library(
@@ -65,7 +65,7 @@ java_library(
     neverlink = 1,
     visibility = ["//:__subpackages__"],
     exports = [
-        "@com_google_auto_value_auto_value_annotations//jar",
-        "@org_apache_tomcat_annotations_api//jar",  # @Generated for Java 9+
+        "@grpc_java_maven//:com_google_auto_value_auto_value_annotations",
+        "@grpc_java_maven//:org_apache_tomcat_annotations_api",  # @Generated for Java 9+
     ],
 )
diff --git a/alts/BUILD.bazel b/alts/BUILD.bazel
index c99689bac..2264c1023 100644
--- a/alts/BUILD.bazel
+++ b/alts/BUILD.bazel
@@ -14,16 +14,16 @@ java_library(
         "//grpclb",
         "//netty",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
         "@com_google_protobuf//:protobuf_java",
         "@com_google_protobuf//:protobuf_java_util",
-        "@io_netty_netty_buffer//jar",
-        "@io_netty_netty_codec//jar",
-        "@io_netty_netty_common//jar",
-        "@io_netty_netty_handler//jar",
-        "@io_netty_netty_transport//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:io_netty_netty_buffer",
+        "@grpc_java_maven//:io_netty_netty_codec",
+        "@grpc_java_maven//:io_netty_netty_common",
+        "@grpc_java_maven//:io_netty_netty_handler",
+        "@grpc_java_maven//:io_netty_netty_transport",
     ],
 )
 
@@ -35,19 +35,19 @@ java_library(
     visibility = ["//visibility:public"],
     deps = [
         ":alts_internal",
-        ":handshaker_java_proto",
         ":handshaker_java_grpc",
+        ":handshaker_java_proto",
         "//api",
         "//auth",
         "//core:internal",
         "//netty",
-        "@com_google_auth_google_auth_library_oauth2_http//jar",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@io_netty_netty_common//jar",
-        "@io_netty_netty_handler//jar",
-        "@io_netty_netty_transport//jar",
+        "@grpc_java_maven//:com_google_auth_google_auth_library_oauth2_http",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:io_netty_netty_common",
+        "@grpc_java_maven//:io_netty_netty_handler",
+        "@grpc_java_maven//:io_netty_netty_transport",
     ],
 )
 
diff --git a/api/BUILD.bazel b/api/BUILD.bazel
index efd1e8d96..ab6782304 100644
--- a/api/BUILD.bazel
+++ b/api/BUILD.bazel
@@ -7,10 +7,10 @@ java_library(
     javacopts = ["-Xep:DoNotCall:OFF"],  # Remove once requiring Bazel 3.4.0+; allows non-final
     visibility = ["//visibility:public"],
     deps = [
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_failureaccess//jar",  # future transitive dep of Guava. See #5214
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_failureaccess",  # future transitive dep of Guava. See #5214
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ],
 )
diff --git a/auth/BUILD.bazel b/auth/BUILD.bazel
index cc923dce2..66863ade3 100644
--- a/auth/BUILD.bazel
+++ b/auth/BUILD.bazel
@@ -6,9 +6,9 @@ java_library(
     visibility = ["//visibility:public"],
     deps = [
         "//api",
-        "@com_google_auth_google_auth_library_credentials//jar",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "@grpc_java_maven//:com_google_auth_google_auth_library_credentials",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ],
 )
diff --git a/census/BUILD.bazel b/census/BUILD.bazel
index c0bf29b3f..1b1b8dba2 100644
--- a/census/BUILD.bazel
+++ b/census/BUILD.bazel
@@ -5,11 +5,11 @@ java_library(
     ]),
     visibility = ["//visibility:public"],
     deps = [
-            "//api",
-            "//context",
-            "@com_google_code_findbugs_jsr305//jar",
-            "@com_google_guava_guava//jar",
-            "@io_opencensus_opencensus_api//jar",
-            "@io_opencensus_opencensus_contrib_grpc_metrics//jar",
+        "//api",
+        "//context",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:io_opencensus_opencensus_api",
+        "@grpc_java_maven//:io_opencensus_opencensus_contrib_grpc_metrics",
     ],
 )
diff --git a/compiler/BUILD.bazel b/compiler/BUILD.bazel
index f88075c0e..81c91ac55 100644
--- a/compiler/BUILD.bazel
+++ b/compiler/BUILD.bazel
@@ -22,9 +22,9 @@ java_library(
         "//protobuf",
         "//stub",
         "//stub:javax_annotation",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
         "@com_google_protobuf//:protobuf_java",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
@@ -35,8 +35,8 @@ java_library(
         "//protobuf-lite",
         "//stub",
         "//stub:javax_annotation",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
diff --git a/core/BUILD.bazel b/core/BUILD.bazel
index ebe5b64c2..fa499a01c 100644
--- a/core/BUILD.bazel
+++ b/core/BUILD.bazel
@@ -23,14 +23,14 @@ java_library(
     deps = [
         "//api",
         "//context",
-        "@com_google_android_annotations//jar",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_code_gson_gson//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@io_perfmark_perfmark_api//jar",
-        "@org_codehaus_mojo_animal_sniffer_annotations//jar",
+        "@grpc_java_maven//:com_google_android_annotations",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_code_gson_gson",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:io_perfmark_perfmark_api",
+        "@grpc_java_maven//:org_codehaus_mojo_animal_sniffer_annotations",
     ],
 )
 
diff --git a/googleapis/BUILD.bazel b/googleapis/BUILD.bazel
index 77b0bcd93..758be86c4 100644
--- a/googleapis/BUILD.bazel
+++ b/googleapis/BUILD.bazel
@@ -9,6 +9,6 @@ java_library(
         "//api",
         "//core:internal",
         "//xds",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
diff --git a/grpclb/BUILD.bazel b/grpclb/BUILD.bazel
index e82d8022b..c58a36a9f 100644
--- a/grpclb/BUILD.bazel
+++ b/grpclb/BUILD.bazel
@@ -14,12 +14,12 @@ java_library(
         "//api",
         "//context",
         "//core:internal",
-        "//util",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "//util",
         "@com_google_protobuf//:protobuf_java_util",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
         "@io_grpc_grpc_proto//:grpclb_load_balancer_java_proto",
     ],
 )
diff --git a/inprocess/BUILD.bazel b/inprocess/BUILD.bazel
index 65f2adced..92112ebb3 100644
--- a/inprocess/BUILD.bazel
+++ b/inprocess/BUILD.bazel
@@ -5,12 +5,12 @@ java_library(
     ]),
     visibility = ["//visibility:public"],
     deps = [
-        "//core:internal",
         "//api",
         "//context",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "//core:internal",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ],
 )
diff --git a/netty/BUILD.bazel b/netty/BUILD.bazel
index d2497d065..4fb1809c7 100644
--- a/netty/BUILD.bazel
+++ b/netty/BUILD.bazel
@@ -10,22 +10,22 @@ java_library(
     deps = [
         "//api",
         "//core:internal",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@io_netty_netty_buffer//jar",
-        "@io_netty_netty_codec//jar",
-        "@io_netty_netty_codec_http//jar",
-        "@io_netty_netty_codec_http2//jar",
-        "@io_netty_netty_codec_socks//jar",
-        "@io_netty_netty_common//jar",
-        "@io_netty_netty_handler//jar",
-        "@io_netty_netty_handler_proxy//jar",
-        "@io_netty_netty_resolver//jar",
-        "@io_netty_netty_transport//jar",
-        "@io_netty_netty_transport_native_unix_common//jar",
-        "@io_perfmark_perfmark_api//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:io_netty_netty_buffer",
+        "@grpc_java_maven//:io_netty_netty_codec",
+        "@grpc_java_maven//:io_netty_netty_codec_http",
+        "@grpc_java_maven//:io_netty_netty_codec_http2",
+        "@grpc_java_maven//:io_netty_netty_codec_socks",
+        "@grpc_java_maven//:io_netty_netty_common",
+        "@grpc_java_maven//:io_netty_netty_handler",
+        "@grpc_java_maven//:io_netty_netty_handler_proxy",
+        "@grpc_java_maven//:io_netty_netty_resolver",
+        "@grpc_java_maven//:io_netty_netty_transport",
+        "@grpc_java_maven//:io_netty_netty_transport_native_unix_common",
+        "@grpc_java_maven//:io_perfmark_perfmark_api",
     ],
 )
 
diff --git a/netty/shaded/BUILD.bazel b/netty/shaded/BUILD.bazel
index 657bf6aaf..9ce69760a 100644
--- a/netty/shaded/BUILD.bazel
+++ b/netty/shaded/BUILD.bazel
@@ -4,9 +4,9 @@ java_library(
     visibility = ["//netty:__pkg__"],
     runtime_deps = [
         "//netty",
-        "@io_netty_netty_tcnative_boringssl_static//jar",
-        "@io_netty_netty_tcnative_classes//jar",
-        "@io_netty_netty_transport_native_unix_common//jar",
-        "@io_netty_netty_transport_native_epoll_linux_x86_64//jar",
+        "@grpc_java_maven//:io_netty_netty_tcnative_boringssl_static",
+        "@grpc_java_maven//:io_netty_netty_tcnative_classes",
+        "@grpc_java_maven//:io_netty_netty_transport_native_unix_common",
+        "@grpc_java_maven//:io_netty_netty_transport_native_epoll_linux_x86_64",
     ],
 )
diff --git a/okhttp/BUILD.bazel b/okhttp/BUILD.bazel
index 30a77b114..b7ede3995 100644
--- a/okhttp/BUILD.bazel
+++ b/okhttp/BUILD.bazel
@@ -12,12 +12,12 @@ java_library(
         "//api",
         "//core:internal",
         "//util",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@com_squareup_okhttp_okhttp//jar",
-        "@com_squareup_okio_okio//jar",
-        "@io_perfmark_perfmark_api//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:com_squareup_okhttp_okhttp",
+        "@grpc_java_maven//:com_squareup_okio_okio",
+        "@grpc_java_maven//:io_perfmark_perfmark_api",
     ],
 )
diff --git a/protobuf-lite/BUILD.bazel b/protobuf-lite/BUILD.bazel
index 85cd9669e..73ecf34c6 100644
--- a/protobuf-lite/BUILD.bazel
+++ b/protobuf-lite/BUILD.bazel
@@ -6,9 +6,9 @@ java_library(
     visibility = ["//visibility:public"],
     deps = [
         "//api",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ] + select({
         ":android": ["@com_google_protobuf_javalite//:protobuf_javalite"],
         "//conditions:default": ["@com_google_protobuf//:protobuf_java"],
diff --git a/protobuf/BUILD.bazel b/protobuf/BUILD.bazel
index 42085eea5..a7acceeb7 100644
--- a/protobuf/BUILD.bazel
+++ b/protobuf/BUILD.bazel
@@ -7,10 +7,10 @@ java_library(
     deps = [
         "//api",
         "//protobuf-lite",
-        "@com_google_api_grpc_proto_google_common_protos//jar",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
         "@com_google_protobuf//:protobuf_java",
+        "@grpc_java_maven//:com_google_api_grpc_proto_google_common_protos",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ],
 )
diff --git a/repositories.bzl b/repositories.bzl
index 942a347cb..100014fc0 100644
--- a/repositories.bzl
+++ b/repositories.bzl
@@ -83,7 +83,7 @@ IO_GRPC_GRPC_JAVA_OVERRIDE_TARGETS = {
     "io.grpc:grpc-util": "@io_grpc_grpc_java//util",
 }
 
-def grpc_java_repositories():
+def grpc_java_repositories(bzlmod = False):
     """Imports dependencies for grpc-java."""
     if not native.existing_rule("com_github_cncf_xds"):
         http_archive(
@@ -94,7 +94,7 @@ def grpc_java_repositories():
                 "https://github.com/cncf/xds/archive/e9ce68804cb4e64cab5a52e3c8baf840d4ff87b7.tar.gz",
             ],
         )
-    if not native.existing_rule("com_github_grpc_grpc"):
+    if not bzlmod and not native.existing_rule("com_github_grpc_grpc"):
         http_archive(
             name = "com_github_grpc_grpc",
             strip_prefix = "grpc-1.46.0",
@@ -103,11 +103,11 @@ def grpc_java_repositories():
                 "https://github.com/grpc/grpc/archive/v1.46.0.tar.gz",
             ],
         )
-    if not native.existing_rule("com_google_protobuf"):
+    if not bzlmod and not native.existing_rule("com_google_protobuf"):
         com_google_protobuf()
-    if not native.existing_rule("com_google_protobuf_javalite"):
+    if not bzlmod and not native.existing_rule("com_google_protobuf_javalite"):
         com_google_protobuf_javalite()
-    if not native.existing_rule("com_google_googleapis"):
+    if not bzlmod and not native.existing_rule("com_google_googleapis"):
         http_archive(
             name = "com_google_googleapis",
             sha256 = "49930468563dd48283e8301e8d4e71436bf6d27ac27c235224cc1a098710835d",
@@ -116,7 +116,7 @@ def grpc_java_repositories():
                 "https://github.com/googleapis/googleapis/archive/ca1372c6d7bcb199638ebfdb40d2b2660bab7b88.tar.gz",
             ],
         )
-    if not native.existing_rule("io_bazel_rules_go"):
+    if not bzlmod and not native.existing_rule("io_bazel_rules_go"):
         http_archive(
             name = "io_bazel_rules_go",
             sha256 = "ab21448cef298740765f33a7f5acee0607203e4ea321219f2a4c85a6e0fb0a27",
@@ -164,3 +164,8 @@ def io_grpc_grpc_proto():
         strip_prefix = "grpc-proto-08911e9d585cbda3a55eb1dcc4b99c89aebccff8",
         urls = ["https://github.com/grpc/grpc-proto/archive/08911e9d585cbda3a55eb1dcc4b99c89aebccff8.zip"],
     )
+
+def _grpc_java_repositories_extension(_):
+    grpc_java_repositories(bzlmod = True)
+
+grpc_java_repositories_extension = module_extension(implementation = _grpc_java_repositories_extension)
diff --git a/rls/BUILD.bazel b/rls/BUILD.bazel
index c67c7cd56..0be74a662 100644
--- a/rls/BUILD.bazel
+++ b/rls/BUILD.bazel
@@ -12,11 +12,11 @@ java_library(
         "//api",
         "//core",
         "//core:internal",
-        "//util",
         "//stub",
-        "@com_google_auto_value_auto_value_annotations//jar",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "//util",
+        "@grpc_java_maven//:com_google_auto_value_auto_value_annotations",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
         "@io_grpc_grpc_proto//:rls_config_java_proto",
         "@io_grpc_grpc_proto//:rls_java_proto",
     ],
diff --git a/services/BUILD.bazel b/services/BUILD.bazel
index fa708dd04..fbf34d485 100644
--- a/services/BUILD.bazel
+++ b/services/BUILD.bazel
@@ -26,7 +26,7 @@ java_library(
     deps = [
         ":channelz",
         "//api",
-        "@com_google_code_findbugs_jsr305//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
     ],
 )
 
@@ -35,15 +35,15 @@ java_library(
     srcs = [
         "src/main/java/io/grpc/services/CallMetricRecorder.java",
         "src/main/java/io/grpc/services/MetricRecorder.java",
-        "src/main/java/io/grpc/services/MetricReport.java",
         "src/main/java/io/grpc/services/MetricRecorderHelper.java",
+        "src/main/java/io/grpc/services/MetricReport.java",
     ],
     deps = [
         "//api",
         "//context",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
@@ -72,10 +72,10 @@ java_library(
         ":_channelz_java_grpc",
         "//api",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
         "@com_google_protobuf//:protobuf_java",
         "@com_google_protobuf//:protobuf_java_util",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
         "@io_grpc_grpc_proto//:channelz_java_proto",
     ],
 )
@@ -90,10 +90,10 @@ java_library(
         "//api",
         "//protobuf",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
         "@com_google_protobuf//:protobuf_java",
         "@com_google_protobuf//:protobuf_java_util",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
         "@io_grpc_grpc_proto//:reflection_java_proto_deprecated",
     ],
 )
@@ -110,8 +110,8 @@ java_library(
         "//api",
         "//context",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
         "@io_grpc_grpc_proto//:health_java_proto",
     ],
 )
@@ -131,8 +131,8 @@ java_library(
         "//api",
         "//core:internal",
         "//util",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
         "@io_grpc_grpc_proto//:health_java_proto",
     ],
 )
diff --git a/stub/BUILD.bazel b/stub/BUILD.bazel
index c65b01a23..3131a3632 100644
--- a/stub/BUILD.bazel
+++ b/stub/BUILD.bazel
@@ -7,10 +7,10 @@ java_library(
     deps = [
         "//api",
         "//context",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
     ],
 )
 
@@ -20,5 +20,5 @@ java_library(
     name = "javax_annotation",
     neverlink = 1,  # @Generated is source-retention
     visibility = ["//visibility:public"],
-    exports = ["@org_apache_tomcat_annotations_api//jar"],
+    exports = ["@grpc_java_maven//:org_apache_tomcat_annotations_api"],
 )
diff --git a/testing/BUILD.bazel b/testing/BUILD.bazel
index 974cb32f7..69ee8b651 100644
--- a/testing/BUILD.bazel
+++ b/testing/BUILD.bazel
@@ -12,12 +12,12 @@ java_library(
         "//api",
         "//context",
         "//inprocess",
-        "//util",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@com_google_truth_truth//jar",
-        "@junit_junit//jar",
+        "//util",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:com_google_truth_truth",
+        "@grpc_java_maven//:junit_junit",
     ],
 )
diff --git a/util/BUILD.bazel b/util/BUILD.bazel
index b95e428f4..cd1402886 100644
--- a/util/BUILD.bazel
+++ b/util/BUILD.bazel
@@ -10,9 +10,9 @@ java_library(
     deps = [
         "//api",
         "//core:internal",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
-        "@com_google_j2objc_j2objc_annotations//jar",
-        "@org_codehaus_mojo_animal_sniffer_annotations//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_j2objc_j2objc_annotations",
+        "@grpc_java_maven//:org_codehaus_mojo_animal_sniffer_annotations",
     ],
 )
diff --git a/xds/BUILD.bazel b/xds/BUILD.bazel
index d3b746e39..e5349ebbe 100644
--- a/xds/BUILD.bazel
+++ b/xds/BUILD.bazel
@@ -31,31 +31,31 @@ java_library(
         ":envoy_service_load_stats_v2_java_grpc",
         ":envoy_service_load_stats_v3_java_grpc",
         ":envoy_service_status_v3_java_grpc",
-        ":xds_protos_java",
         ":orca",
+        ":xds_protos_java",
         "//:auto_value_annotations",
         "//alts",
         "//api",
         "//context",
         "//core:internal",
-        "//util",
         "//netty",
-        "//stub",
         "//services:metrics",
         "//services:metrics_internal",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_code_gson_gson//jar",
-        "@com_google_errorprone_error_prone_annotations//jar",
+        "//stub",
+        "//util",
         "@com_google_googleapis//google/rpc:rpc_java_proto",
-        "@com_google_guava_guava//jar",
         "@com_google_protobuf//:protobuf_java",
         "@com_google_protobuf//:protobuf_java_util",
-        "@com_google_re2j_re2j//jar",
-        "@io_netty_netty_buffer//jar",
-        "@io_netty_netty_codec//jar",
-        "@io_netty_netty_common//jar",
-        "@io_netty_netty_handler//jar",
-        "@io_netty_netty_transport//jar",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_code_gson_gson",
+        "@grpc_java_maven//:com_google_errorprone_error_prone_annotations",
+        "@grpc_java_maven//:com_google_guava_guava",
+        "@grpc_java_maven//:com_google_re2j_re2j",
+        "@grpc_java_maven//:io_netty_netty_buffer",
+        "@grpc_java_maven//:io_netty_netty_codec",
+        "@grpc_java_maven//:io_netty_netty_common",
+        "@grpc_java_maven//:io_netty_netty_handler",
+        "@grpc_java_maven//:io_netty_netty_transport",
     ],
 )
 
@@ -145,14 +145,14 @@ java_library(
         "//api",
         "//context",
         "//core:internal",
-        "//util",
         "//protobuf",
         "//services:metrics",
         "//services:metrics_internal",
         "//stub",
-        "@com_google_code_findbugs_jsr305//jar",
-        "@com_google_guava_guava//jar",
+        "//util",
         "@com_google_protobuf//:protobuf_java_util",
+        "@grpc_java_maven//:com_google_code_findbugs_jsr305",
+        "@grpc_java_maven//:com_google_guava_guava",
     ],
 )
 
